/*
  Product Version: MPLAB X IDE v6.00
  Company:     Microchip Technology Inc.
  File Name:     main.c
  Summary:     This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs
  Description:
  This header file provides implementations for driver APIs for all modules selected in the GUI.
  Generation Information :
  Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
  Device            :  PIC18F27K42
  Driver Version    :  2.00

*/
#define VERSION "2022-0322"
// SPI clock  32MHz et revision Ecran_Noir
//#define VERSION "2022-0322"
// SPI clock  16MHz
//#define VERSION "2022-0321"
// SPI clock  8MHz
//modif SMT1 ..debordment si source FOSC
//#define VERSION "2022-0320"
// modif SMT1 ..source 500Khz pour eviter les debordements
// rajout compteur SMT1
// modif SRLCONC pour SPI  8MHz
// modif init SPI .. Satinas)
// suppression Tests SPI avant init LCD
// test  SPI 2MHz ..OK , test  SPI 8MHz
//#define VERSION "2022-0318"
// #define With_SPI_Software   // Test OLED OK !



#include "xc.h"

#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>
//#include <conio.h>
#include "Config_bits.h"

#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"
#define UART1_RX_BUFFER_SIZE 128  
#define BR        115200       // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1) // brgs=1

#define Max_Lcd_Buff  240*240
#define _maxX 240
#define _maxY 240

#define With_SPI_Hardware 

#include "Defines_datas.h"
#include "RGB_565_colors.h"
#include "Init_GC9A01.h"
#include "voltmetre_565.h"

#pragma warning disable 1498
#pragma warning disable 31
#pragma warning disable 228   // caractere francais accentu
#pragma warning disable 520  
#pragma warning disable 1510 
#pragma warning disable 759
#pragma warning disable  2053
#pragma warning disable  2020
#pragma warning disable 359
#pragma warning disable 373

/*

 
#ifndef Word
#define Word uint16_t
#endif

#ifndef Byte
#define Byte uint8_t
#endif

#define CR 13
#define LF 10
#define TAB 9* 
 * 
 *  * 
#define Led_R_Dir  TRISAbits.TRISA4
#define Led_R     LATAbits.LATA4
#define SQA_Dir  TRISAbits.TRISA3
#define SQA      LATAbits.LATA3

 
 * 
#define _RC2      LATCbits.LATC2  
#define _RST        LATBbits.LATB0
#define _CS         LATBbits.LATB1
#define _DC         LATBbits.LATB2
#define _RST_Dir    TRISBbits.TRISB0
#define _CS_Dir     TRISBbits.TRISB1
#define _DC_Dir     TRISBbits.TRISB2

#define SCL         LATCbits.LATC3
#define SData       LATCbits.LATC5
#define MISO        PORTCbits.RC4

#define SCL_Dir         TRISCbits.TRISC3
#define MISO_Dir        TRISCbits.TRISC4
#define SData_Dir       TRISCbits.TRISC5
#define Cde 0
#define Donnee 1
 * */

extern volatile __uint24   SMT1TMR  __at(0x3F12);

static uint32_t  SMT1_Measure=0;
static  uint32_t L1;
static uint8_t *ST;
// uint32_t L0,L2;


uint16_t  i,j,k,l,m,n;
uint16_t  Rep;
uint8_t  c1,c2,c3,cx,cc;
uint8_t  temp=0;
volatile uint8_t Buffer1[UART1_RX_BUFFER_SIZE];
volatile uint16_t Index1,i1;
volatile uint8_t Flag_Buffer1=0;

uint8_t TEXTE [128];
uint8_t * txt;
uint8_t * p0;
const uint8_t * p1;
const uint8_t * p2;
uint8_t * px;
uint8_t CRam1[80];

float F0,F1,F2;

uint32_t  SPI_SPEED=0;
// compteur Timers
volatile uint16_t Count0, Count1 ;
volatile uint16_t Cpt0, Cpt1;
volatile uint16_t Flag_Timer1=0;
volatile uint16_t Flag_Timer6=0;
volatile signed int  Cpt6;  
bool Status_GIE_Bit;
bool Etat_SPI;

volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  libre:1;
 }Drapeaux ;
 
void Init_Hardware(void) ;
void Interrupt_Init(void);
void  UART1_Init(void); 
void TMR6_Init_500ms(char N);
void RAZ_UART1_Buffer1(void);
void PrintChar(uint8_t txData);
void Print (char * T1);
void CPrint (const char * T1);
void CRLF1(void);
void strConstRamCpy(uint8_t  *dest, const  uint8_t *source);
void Delay_xS(uint8_t N);

void SetWindow(uint16_t x1, uint16_t  y1, uint16_t  x2, uint16_t  y2);
void Init_CG9A01(void);
void Rectangle_Plein(int x1,int y1, int x2,int y2,Word color);
void Clear_LCD(void);

void SMT1_Init(void);
void Start_SMT1(void);
void Stop_SMT1(void);

#ifdef With_SPI_Hardware
void My_Init_SPI1(void);
Byte  SPI1_WriteByte(uint8_t bb);
#endif

void  Interrupt_Init(void)
{
    INTCON0bits.IPEN = 1;

    bool state = (unsigned char)GIE;
    GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT

    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;

    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT

    GIE = state;

    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
 //   IPR1bits.INT0IP = 1;
 //   IPR4bits.TMR1IP = 1;
    IPR9bits.TMR6IP = 1;
  //  IPR7bits.TMR4IP = 0;
  //  IPR0bits.IOCIP=1;
}


void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}

void __interrupt(irq(IRQ_TMR6),high_priority) TMR6_ISR(void)
{  
    if (  (TMR6IF==1) && (TMR6IE==1) )
    {
      if (Cpt6>0)  // decomptage maxi 32767
       {
         Cpt6--;
        }
      else
      {
        Drapeaux.Tmr6_Elapsed=1;
        TMR6IE=0;
      } 
     Flag_Timer6=1;
     TMR6IF=0;// clear the TMR6 interrupt flag
     
    }       
 }


void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
    U1CON2 = 0x00;
    U1BRGL = 0x8A; // BRGL 138;   115200 bds
    U1BRGH = 0x00; // BRGH 0; 
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
    // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;  // enable recpetion
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}



void strConstRamCpy(uint8_t  *dest, const  uint8_t *source)
 { static uint8_t cc=0;
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
    *(dest++) =cc;
    source++ ;
  }
  *(dest) = 0 ;    // terminateur
}


void Delay_xSec(Byte N)
{
int i;  
for (i=0;i<N;i++)  __delay_ms(1000);
}

void PrintChar( uint8_t txData)
{
    while(0 == PIR3bits.U1TXIF)
    {
        __asm("NOP");
    }
    U1TXB = txData;    // Write the data byte to the USART.
}

 void Print (char * Tc)
 { static uint16_t k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}


  void CPrint (const char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}

void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }   


void RAZ_UART1_Buffer1(void)
{    
      if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
      for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;

      Flag_Buffer1 =0 ;
      U1CON0bits.U1RXEN=1;
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      Buffer1[0]=0;
      i1=0;
      Index1=0;

      c1=0;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      PIE3bits.U1RXIE =1;  
} 

void TMR6_Init_500ms(char N)
{   
    //  cycle=500 mS modifi -> 1sec !
     PIE9bits.TMR6IE=0 ;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;  // TMR4 0; 
    T6CON = 0x70 | 0x07 ; // Prescaler =7=> 1/128 Poscaler=7=>  1/8 =>  ticks= 512  S
    T6PR=244;   // 512 * (244+1) * 128 * 8 => 501760S ->  500mS sec
   Flag_Timer6=0;
   TMR6ON = 1;
   TMR6IF=0;
   if(N>0) 
   { 
     Cpt6=N;
      PIE9bits.TMR6IE=1 ;  // TMR6IE_bit=1;
   }
   else
   {
       PIE9bits.TMR6IE=0 ; // TMR6IE_bit=0;
        Cpt6=0;      
   } 
 TMR6IF=0;   
 }




void SMT1_Init(void)
{
//04-04-2021 rev 21-03-2023
// registre  SMT1CON0
SMT1CON0bits.SMT1EN =1;    // SMT enabled
SMT1CON0bits.WPOL=0; // Window Polarity
SMT1CON0bits.SPOL=0; // Signal Polarity
SMT1CON0bits.CPOL=0; // Clock Polarity
// prescaler pour Compteur only, ne pas valider pour timer
SMT1CON0bits.SMT1PS1=0; // PS<1:0>: SMT Prescale Select bits = 1/1
SMT1CON0bits.SMT1PS0=0;    // 11=1/8  10=1/4  01=1/2 00=1/1
SMT1CON0bits.SMT1EN =1;    // SMT enabled
SMT1CON0bits.SMT1STP=0;    // 0 =reset 1=STOP;
SMT1CON1bits.SMT1GO=0;     // 1= suit l'entree   0=stop suivi
SMT1CON1bits.SMT1REPEAT=0; // 0= Single  Acquisition   1=repeat mode
// REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER 16MHz
//     000=FOSC/4    001=FOSC  010=HINTOSC 16MHz  100=MFINTOSC 500Khz
// 500KZ    => resolution +-2S
// SMT1CLKbits.CSEL2=  1;
// SMT1CLKbits.CSEL1=  0;  //was 001
// SMT1CLKbits.CSEL0=  0;
// 64MHZ
//SMT1CLKbits.CSEL2=  0;
//SMT1CLKbits.CSEL1=  0;  
//SMT1CLKbits.CSEL0=  1;
// FOSC/4 =16MHZ
SMT1CLKbits.CSEL2=  0;
SMT1CLKbits.CSEL1=  0; 
SMT1CLKbits.CSEL0=  0;
// 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
PIR1bits.SMT1PRAIF=0;
PIE1bits.SMT1PRAIE=0;
//  25.7.2  PERIOD MATCHI NTERRUPT
PIR1bits.SMT1IF=0;
PIE1bits.SMT1IE=0;
// init  compteur
SMT1PRU=0xFF;
SMT1PRH=0xFF;
SMT1PRL=0xFF;
// MODE de fonctionnement TIMER  page 396
//   0000=Timer   0100=windowed measure  1000=counter
//SMT1CON1=0;
SMT1CON1bits.MODE3=0;
SMT1CON1bits.MODE2=0;
SMT1CON1bits.MODE1=0;
SMT1CON1bits.MODE0=0;
}

void Init_Hardware()
{
    LATA = 0x00;
    LATB = 0x00;
    LATC = 0x00;
    

    TRISA = 0xFF; 
    TRISB = 0xF8;
    TRISC = 0x80;
  
    ANSELA = 0x02;  // RA1 analog
    ANSELC = 0x00;
    ANSELB = 0x00;
    
    Led_R_Dir =0;
    Led_R =0;
    SQA_Dir =0;   
    SQA=0;
 

    WPUE = 0x00;
    WPUB = 0x07;
    WPUA = 0x00;
    WPUC = 0x80;

  

    /**
    ODx registers
    */
    ODCONA = 0x00;
    ODCONB = 0x00;
  //  ODCONC = 0x18; //I2C!
    ODCONC = 0x00; //I2C!

    /**
    SLRCONx registers
    */
    SLRCONA = 0xFF;
    SLRCONB = 0xFF;
    SLRCONC = 0x80;  //// pas de slow rate sur SPI

    /**
    INLVLx registers
    */
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    RA3PPS=0;
 // RB1I2C = 0x00;
 // RB2I2C = 0x00;
 // RC3I2C = 0x00;
 // RC4I2C = 0x00;
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RC3PPS = 0x00;
    RC4PPS = 0x00;
  
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
  
    U1RXPPS = 0x17;   //RC7->UART1:RX1;  
    U1CTSPPS = 0x00;
    RC5PPS=0;  // RC5
   
    _CS_Dir=0; 
    _DC_Dir=0; 
    _RST_Dir=0;
    SCL_Dir=0;
    SData_Dir=0;
    
   
#ifdef With_I2C1
    //    ODCONCbits.ODCC3=1;
    //   ODCONCbits.ODCC4=1; // open collecteur sur RC4
    //  SCL_Dir=0; //  TRISCbits.TRISC3
    //  SData_Dir=0; // TRISCbits.TRISC4
    //    RC3PPS = 0x21;   //RC3->I2C1:SCL1;    
    //    RC4PPS = 0x22;   //RC4->I2C1:SDA1;  
#endif
  
   
  #ifdef With_SPI_Hardware   
 // TABLE 17-2: PPS OUTPUT REGISTER DETAILS  p282
    RC3PPS=0x1E; //0b01 1110 SPI1 (SCK)
    RC5PPS = 0x1F; //RC5->SPI1:SDO1; 
 //   SPI1SDIPPS = 0x14;   //RC4->SPI1:SDI1;   
 //   SPI1SCKPPS = 0x13;   //RC3->SPI1:SCK1;  
 //   RC2PPS = 0x20; //RC2->SS1

 #endif 
    
    _RST=1;
    _CS=1;
    _DC=0;
    PIE2bits.SPI1IE=0;
    PIE2bits.SPI1RXIE=0;
    PIE2bits.SPI1TXIE=0;
  }


 

#ifdef With_SPI_Software  
void SendData(unsigned char value)
{  unsigned char i,cx;
    cx=value;
    _DC=1;
     for(i=0;i<8;i++)
     {   if((cx&0x80)==0x80)
         SData=1;  
           else 
            SData=0;
     __asm("Nop");
     SCL=1; 
     __asm ("nop");
       SCL=0;
       cx=cx<<1;
     }
}

void SendCmd(unsigned char value)
{ unsigned char i,cx;
    cx=value;
    _DC=0;
    for(i=0;i<8;i++)
     {  
           if((cx&0x80)==0x80)
         SData=1;  
           else 
            SData=0;
      __asm("Nop");
      SCL=1; 
      __asm("Nop");
      SCL=0;
      cx=cx<<1;
      }
}
#endif


void PutPixel(Word x,Word y,Word Couleur)
{
   Byte a,b;
   SendCmd(0x2A);
    a=x>>8;  
   SendData(a);
    b=x&0x0F;
   SendData(b);
    
   SendCmd(0x2B);
    a=y>>8;  
   SendData(a);
    b=y&0x0F;
   SendData(b);
    
   SendCmd(0x2C);
    a=(Couleur >> 8);  
   SendData(a);
    b=(Couleur & 0x0F);
   SendData(b);
 }  

void Put_Big_Pixel(uint16_t x1,uint16_t y1, Word color)
{   uint16_t i,j;
   if(  (x1 >= _maxX-2) || (y1 >= (_maxY-2))||(x1 <2) || (y1 <2 )) return;
   SetWindow(x1-2,y1-2,x1+2, y1+2);
  for (i=0;i<8;i++)
  {
  SendData(color>>8);
  SendData(color & 0x00FF);
  }
}
  
void Ecran_Noir_VO(void)
{ Word i;
  SendCmd(0x2A);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2B);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2C);
  for (i=0;i<57600;i++)
  { SendData(0x00);SendData(0x00);
  }
 
}

void Ecran_Noir_2(void)
{ Word i;
  SendCmd(0x2A);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2B);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2C);
  for (i=0;i<5760;i++)
  { SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  
  }
 
}

void Ecran_Noir(void)
{ Word i;
  SendCmd(0x2A);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2B);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2C);
  i=0;
  do
  {
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  i++;
  }while(i<5760);
 
}


void SetWindow(uint16_t x1, uint16_t  y1, uint16_t  x2, uint16_t  y2)
{  Byte a,b;
  SendCmd(0x2A);                    // set column address
  a=(x1>>8); b=(x1&0x00ff);  SendData(a);SendData(b);
  a=(x2>>8); b=(x2&0x00ff); SendData(a);SendData(b);
  SendCmd(0x2B);   // set page address (=row)
  a=(y1>>8); b=(y1&0x00ff);  SendData(a);SendData(b);
  a=(y2>>8); b=(y2&0x00ff); SendData(a);SendData(b);
  SendCmd(0x2C);  // ecrit en RAM
}


void Rectangle_Plein(int x1,int y1, int x2,int y2,Word color)
{ int i,j,dx,dy;
  SendCmd(0x2A);
  SendData(x1>>8);SendData(x1 &0x00FF);
  SendData(x2>>8);SendData(x2 &0x00FF);
  SendCmd(0x2B);
  SendData(y1>>8);SendData(y1 &0x00FF);
  SendData(y2>>8);SendData(y2 &0x00FF);
 // SendCmd(0x2C);
  dx=abs(x2-x1)+1;
  dy=abs(y2-y1)+1;
  SendCmd(0x2C);
  for (i=0;i<dx;i++)
  {
   for (j=0;j<dy;j++) 
   {
   SendData(color>>8);
   SendData(color & 0x00FF);
   }
  }
}

void Clear_LCD(void)
{
 Word i1;    // taille Word suffisante avec ecan 240x240  mais usage d'un  Long si ecran 320x240 !!
 SendCmd(0x2A);                    // set column address
  SendData(0); SendData(0);
  SendData(0); SendData(239);
  SendCmd(0x2B);                    // set page address (=row)
  SendData(0); SendData(0);
  SendData(0); SendData(239);
  SendCmd(0x2C);  // ecrit en RAM
  for (i1=0;i1<57600;i1++)
  {
    SendData(0);
    SendData(0);
  }
}

 #ifdef With_SPI_Hardware  

void My_Init_SPI1(void)
{ //rev 20-03-2023
  // 3D14h SPI1CON0 : EN ? ? ? ? LSBF MST BMODE  .page 540   
  SPI1CON0 = 0x00;
  SPI1CON0bits.EN = 0;// on  
  SPI1CON0bits.MST=1;  // SPI module operates as the bus host  
  SPI1CON0bits.BMODE=1;  
  // SPI1CON0 = 0x03;    // off, msb first, master, BMODE=1
  // 3D15h SPI1CON1:  SMP CKE CKP FST ? SSP SDIP SDOP . page 541
  SPI1CON1 = 0x00;   
  SPI1CON1bits.SMP =0;// reserved ???
  SPI1CON1bits.CKE=1; // 1= Data change sur front descendant ,0 = changes sur Front Montant
  SPI1CON1bits.CKP=0; // Clock Polarity 0 = Idle state for SCK is low level
  SPI1CON1bits.FST=1;// Fast Start Enable bit  1 = Delay to first SCK may be <  baud period  0 = Delay to first SCK >  baud period
  //En mode 0 et 3, le pic crit le bit au front descendant, le slave lit au front montant.
  //En mode 1 et 2, le pic crit le bit au front montant, le slave lit au front descendant.
  //mode 0 (CKP=0, CKE=1)<-- OK
  //mode 1 (CKP=CKE=0) 
  //mode 2 (CKP=CKE=1).       
  //mode 3 (CKP=1, CKE=0)
   //mode0  ok
  //SPICON2  : BUSY(1) SSFLT ? ? ? SSET TXR(2) RXR  page 541
  SPI1CON2=0x00;
  //19/03
  // SPI1CON2 = 0x03;    // SSET=0, TXR=1, RXR=1
  // SPI1CON2bits.BUSY  en lecture seule
  SPI1CON2bits.SSET=1;// host mode :  0 = SS(out) is driven to the active state while the transmit counter is not zero
                     // host mode  :  1 = SS(out) is driven to the active state continuously
  SPI1CON2bits.TXR=1; //1 = TxFIFO data is required for a transfer
  SPI1CON2bits.RXR=1; // 0=Received data is not stored in the FIFO  1=1 = Data transfers are suspended if the RxFIFO is full
  // The BUSY bit is subject to synchronization delay of up to two instruction cycles.
  // CLKREF :  2->MFINTOSC=500Khz , 1->HFINTOSC=16Mhz  ,0->FOSC=64MHz
  // SPI1CLK  = 1;     //CLKREF =1   
  // SPI1BAUD = 3;     // SPI Speed 16MHz / (2x(3+1)) = 16/8 = 2MHz .. OK
  //  SPI1CLK  = 1;    
  //  SPI1BAUD = 1;     // SPI Speed 16MHz / (2x(1+1)) = 16/4 = 4MHz 
 //  SPI1CLK  = 0;       // CLKREF =0  ->FOSC=64MHz
 //  SPI1BAUD = 1;       // SPI Speed 64MHz / (2x(3+1)) = 64/8 = 8MHz ..OK!!
  SPI1CLK  = 0;       // CLKREF =0  ->FOSC=64MHz
  SPI1BAUD = 0;       // SPI Speed 64MHz / (2x(0+1)) = 64/2 = 32MHz
  SLRCONC=0; 
  SLRCONB=0; 
  LATCbits.LATC2 = 1; // SS high
  SPI1CON0bits.EN = 1;// on
}

// voir https://fantaspic.fr/viewtopic.php?f=10&t=1292&start=20
//OLED GC9A01 et SPI Hardw 18F27K42
void SendData(Byte c) // SS low par LATC2=0 ayant t fait au pralable
{
  _DC = 1;
  SPI1TXB = c;
 // __asm("NOP");
  // while (!PIR2bits.SPI1RXIF) { };
 c = SPI1RXB;
}

void SendCmd(Byte c) // SS low par LATC2=0 ayant t fait au pralable
{
  _DC = 0;
  SPI1TXB = c;
 //  __asm("NOP");
 //  while (!PIR2bits.SPI1RXIF) { };
   c = SPI1RXB;
}


Byte  SPI1_WriteByte(uint8_t bb) 
{  Byte rep;
    SPI1TCNTH=0;
    SPI1TCNTL=1;   
    SPI1TXB = bb;
    while (!PIR2bits.SPI1RXIF)// Check for any SPI Receive Interrupts;
   {
    }; 
   rep=SPI1RXB;
  return (rep); // Return data from SPI Receive Buffer Register;
}

#endif

  
void Start_SMT1()
{  
     SMT1_Measure=0;
   //PIR1 SMT1PWAIF SMT1PRAIF SMT1IF C1IF ADTIF ADIF ZCDIF INT0IF 138 
    PIR1bits.SMT1IF=0;
    SMT1CON0bits.SMT1STP=0;
    SMT1STATbits.RST=1;   // init FFFFFF
    SMT1CON1bits.SMT1GO=1;
}
    
void Stop_SMT1()
{
    SMT1CON1bits.SMT1GO=0;
    SMT1_Measure=SMT1TMR;
 //   *(ST)=  SMT1TMRL;
 //   *(ST+1)=SMT1TMRH;
 //   *(ST+2)=SMT1TMRU;
  //  *(ST+3)=0;
    
    if (PIR1bits.SMT1IF==1) 
    {
         CPrint("  Over !\r\n");
         SMT1_Measure=SMT1_Measure+0x1000000;
    }   
    PIR1bits.SMT1IF=0 ; 
    sprintf(txt, " Stop. SMT1=%lu ,soit ",SMT1_Measure);
    Print(txt);
    // pour fosc 500Khz
    //L1= SMT1_Measure <<1 ; // *2
    //pour FOSC=64MHz
    //L1= SMT1_Measure >>6 ; //64
     //pour FOSC=16MHz
    L1= SMT1_Measure >>4 ; //16
    sprintf(txt, "%lu uS\r\n",L1); 
    Print(txt);
    CRLF1();  
 }


void main(void)
{
    OSCCON1 = 0x60;
    OSCCON3 = 0x00;
    OSCEN = 0x00;
    OSCFRQ = 0x08;  // 64Mhz
    OSCTUNE = 0x00;
    __delay_ms(1000);
    
   Init_Hardware() ;  // sauf SPI !
   UART1_Init(); 
   
   for (i=0;i<4;i++)
   {
        Led_R=1;
        //__asm("btg LATA,4");  //Led_R
        __delay_ms(500);
         Led_R=0;
        __delay_ms(500);
   }    
    
    k= sizeof(Buffer1)-1;
    for (i=0;i<k;i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(TEXTE)-1;i++) TEXTE[i]=0; 
    txt= &TEXTE[0];
    *(txt)=0; 
    CRLF1(); 
    Cpt6=0;
    
    CRLF1();
    CPrint(" Test SPI Softw ou Hardw 18F27K42\r\n");
    CPrint(" Projet MPLABX : C:\MPLABX_Projects\18F27K42_TEST_SPI_2023.X\18F27K42_TEST_SPI_20232\r\n");
    CPrint(" Version : "VERSION"\r\n"); 
     k=sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d et PACK %s\r\n", __DATE__, __TIME__,__XC8_VERSION,PACK);
    Print(txt);
    CPrint(" Hardware : PIC18F27K42 , FOSC interne =64MHz \r\n");
    CPrint(" UART1  RC6=TX  115200,8,N,1 \r\n");
#ifdef With_SPI_Software
    CPrint(" SPI  SOFWARE :\r\n");
#else
     CPrint(" SPI HARDWARE at 32 MHz:\r\n");
#endif
   CPrint("  RC3=SCLK  RC5=MOSI SDA  RC2=SS  , cdes sur PORTB  RB0=_RST RB1=_CS  RB2=_DC\r\n");
   CRLF1(); 
  
   //REGISTER 21-3: TxCLK: TIMERx CLOCK REGISTER
 //   T6CLK=5;
    // 1=FOSC/4   2 =>FOSC   5=MFINTOSC500Khz
 //  CPrint(" Init Timer6 1sec \r\n");
 //  TMR6_Init_500ms(2)  ;
 //  CRLF1(); 

   SQA=0;
   /*
    __delay_ms(500); 
      CRLF1();
      CPrint(" Test btg RC3 RC4\r\n");
      Delay_xSec(3);
      Led_R=0;
      SQA=1;
     for (i=0;i<8;i++)
   {
        __asm("btg LATA,4");  //Led_R
           __asm("btg LATC,3");  //SCLK
            __asm("btg LATC,5");  //SDA
         __delay_us(100);
   }    
    SQA=0;
    CPrint(" ..fin1\r\n");
     Delay_xSec(3);
  * */
     Led_R=1;
     
#ifdef With_SPI_Software  
    
   /*
     CPrint(" TEST SCL clock ( bit bang)\r\n");
     Delay_xSec(2);
        
     // RC3 ,RC4 et RC5 =>pins normales   
     RC3PPS=0;
     RC4PPS=0;
     RC5PPS=0;
     _RST=1;
     SQA=1;
     for(i=0;i<16;i++)
     {
         SCL=0;
         __delay_us(50);
         SCL=1;
           __delay_us(50);
     }
      SCL=0;
      SQA=0;
    */ 
    
  
      CRLF1();
      CPrint(" TEST SPI software avec SQA analyser SPI1_Bit_Bang\r\n");

    CPrint(" SPI Write  10 Sequences avec trame: 0x01 0x80 0xAA 0x0F 0x55 0xF0 \r\n");
    j=0;
    do
    { 
       PrintChar(' '); PrintChar((j/10)+48);  PrintChar((j%10)+48);
      _RST=1;
      _CS=1;
     __delay_ms(20);
       _CS=0;
     __delay_ms(20);
  
     PrintChar('C');
     SQA=1;
     SendData(0x01); __asm("Nop");__asm("Nop");
     SendData(0x80); __asm("Nop");__asm("Nop"); 
     SendData(0xAA); __asm("Nop");__asm("Nop");  
     SendData(0x0F); __asm("Nop");__asm("Nop");  
     SendData(0x55); __asm("Nop");__asm("Nop"); 
     SendData(0xF0); __asm("Nop");__asm("Nop");     
    __delay_us(1);
    PrintChar('D');
     SendData(0x01);__asm("Nop");__asm("Nop"); 
     SendData(0x80);__asm("Nop");__asm("Nop");  
     SendData(0xAA);__asm("Nop");__asm("Nop"); 
     SendData(0x0F);__asm("Nop");__asm("Nop"); 
     SendData(0x55);__asm("Nop");__asm("Nop"); 
     SendData(0xF0);__asm("Nop");__asm("Nop"); 
      SQA=0; 
    CRLF1(); 
    __delay_ms(200);
    j++;
 
    }
    while(j<10);
#endif   
    
    
    CPrint(" Init et Test Compteur 24 bits SMT1 CLOCK sur FOSC/4=16MHz\r\n");
    CPrint(" Se limiter \0xC3A0 max mesure <= 2secondes\r\n");
    SMT1_Init();
  //  ST=&SMT1_Measure;   // pointeur Byte sur debut entier long 32 bits        

    
#ifdef With_SPI_Hardware    
    CPrint(" Mesure SMT1 pour __delay_ms(50);\r\n");
    Start_SMT1();
     __delay_ms(50);
     Stop_SMT1();
      
    CPrint(" Mesure SMT1 pour __delay_ms(2000);\r\n");
    Start_SMT1();
     __delay_ms(2000);
     Stop_SMT1();
   
    CPrint(" My_Init SPI1\r\n");
    My_Init_SPI1();
    SMT1CON0bits.SMT1EN =1;
     
    j=0;
    CPrint(" TEST signaux SCLK et  MOSI SPI Hardware avec SQA analyser (RA3=Synchro capture)\r\n");
    CPrint(" SPI HARDW Sequence : 0x01 0x10 0X20 0x40 0x80 0xAA 0x0F 0x55 0xF0 \r\n");
    CPrint(" Armer la capture dans 3 sec !\r\n");
    Delay_xSec(3);
    Led_R=0;
        _DC=1;  
        SQA=1;
        SPI1_WriteByte(0x01); 
        SPI1_WriteByte(0x10); 
        SPI1_WriteByte(0x20); 
        SPI1_WriteByte(0x40); 
        SPI1_WriteByte(0x80);
        SPI1_WriteByte(0xAA); 
        SPI1_WriteByte(0x0F);
        SPI1_WriteByte(0x55); 
        SPI1_WriteByte(0xF0);
         SQA=0;      
  #endif    

    CRLF1();  
    CPrint(" Init OLED Rond CG9A01 \r\n");
    CPrint(" Start SMT1 pour Init_CG9A01(); \r\n");
    Start_SMT1();
    Init_CG9A01(); 
    Stop_SMT1();
    Print(" fin d'init LCD\r\n");
   
    CRLF1();
    CPrint(" Clear_LCD() \r\n");
    Clear_LCD();
    CRLF1();
     CPrint(" Test duree Ecran Noir (SPI 32MHz!) \r\n"); 
     Start_SMT1();
     Ecran_Noir();
     Stop_SMT1();
     CRLF1();
    
   do
   {
   Ecran_Noir();  
    __asm("btg LATA,4");
   CPrint(" put 8 big pixels \r\n"); 
   Put_Big_Pixel(40,40,_Blanc);
   Put_Big_Pixel(40,200,_Tomate);
   Put_Big_Pixel(160,120,_Rouge);
   Put_Big_Pixel(60,120,_Jaune); 
   Put_Big_Pixel(180,80,_Magenta);
   Put_Big_Pixel(180,160,_Jaune); 
   Put_Big_Pixel(40,200,_Tomate);
   Put_Big_Pixel(100,160,_Azur);
   Put_Big_Pixel(120,140,_Orange);
    __asm("btg LATA,4");
    Delay_xSec(2);
    
   CPrint(" Ecran Noir \r\n"); 
   Ecran_Noir();  
   
   __asm("btg LATA,4");
   CPrint(" Rectangles Pleins Vert, Beige \r\n"); 
   Rectangle_Plein(0,0,239,239,_Vert);
   Delay_xSec(1);
   Rectangle_Plein(0,0,239,239,_Beige);
   Delay_xSec(2);
   
    Ecran_Noir(); 
    
    CPrint(" Rectangles Pleins Bleu,Blanc,Rouge \r\n");
    Rectangle_Plein(20,20,60,210,_Bleu);
    Rectangle_Plein(60,20,100,210,_Blanc);
    Rectangle_Plein(100,20,140,210,_Rouge);
    __asm("btg LATA,4");  
      Delay_xSec(2);
 
 /*  
    CPrint(" Affichage LadyBug.bmp 240x240 65K couleurs .. OK \r\n");
    CPrint(" tables organisees en mots de 16 bits \r\n");
    CPrint(" partie 1  lignes  0  119 \r\n");
    CPrint(" puis partie 2  lignes  120  232 .. manque 8 lignes ! \r\n");
    SetWindow(0,0,239,239);
    CRLF1();
    SQA=1;
     for (i=0;i<28800 ;i++)    // data en word
     {
      SendData(LadyBug1[i]>>8);  SendData(LadyBug1[i]& 0x00FF);
     }
     CRLF1();
    // CPrint(" partie 2 lignes 220  231 ..manque 8 lignes\r\n");
     for (i=0;i<26880 ;i++)         // data organis en word 26880..OK
     {
      SendData(LadyBug2[i]>>8);  SendData(LadyBug2[i]& 0x00FF);    // data en word
     }
     SQA=0;
     CRLF1();
     CPrint(" ..fin Affichage Image LadyBug \r\n");
     CRLF1();
     Delay_xSec(3);     
   */  
    SetWindow(0,0,239,239); 
    
 
 
    
    CPrint(" Affichage voltmetre.bmp 240x240 65K couleurs .. OK \r\n");
    CPrint(" Image datas organisee en 2 tables de 57600 Bytes  \r\n");
 //   CPrint(" partie 1  lignes  0 a 119 \r\n");
 //   CPrint(" puis partie 2  lignes  120 a 232 \r\n");   
 //   CPrint(" Start chrono SQA dans 3 sec\r\n");
 //   Delay_xSec(3); 
    CRLF1();
    CPrint(" Test Duree de Chargement image Voltmetre.bmp \r\n"); 
    Start_SMT1();
    i=0;
     SQA=1;
  /*   
       do
     { SendData(voltmetre_01[i+1]);  SendData(voltmetre_01[i]);   // organis en byte et non en word
       SendData(voltmetre_01[i+3]);  SendData(voltmetre_01[i+2]);
       SendData(voltmetre_01[i+5]);  SendData(voltmetre_01[i+4]);
       SendData(voltmetre_01[i+7]);  SendData(voltmetre_01[i+6]);
   
       i=i+8;
     } while(i<57600);
   */  
     p1=&voltmetre_01[0];
     for (i=0;i<57600;i=i+8) 
     {   
       SendData(*(p1+1)); SendData(*(p1));
       SendData(*(p1+3)); SendData(*(p1+2));
       SendData(*(p1+5)); SendData(*(p1+4));
       SendData(*(p1+7)); SendData(*(p1+6));
       p1=p1+8;
     }
   /* 
     i=0;
     do
     {  SendData(voltmetre_02[i+1]);  SendData(voltmetre_02[i]);   // organis en byte et non en word
       SendData(voltmetre_02[i+3]);  SendData(voltmetre_02[i+2]);
       SendData(voltmetre_02[i+5]);  SendData(voltmetre_02[i+4]);
       SendData(voltmetre_02[i+7]);  SendData(voltmetre_02[i+6]);
       i=i+8;
      } while(i<57600);
     */
     p2=&voltmetre_02[0];
    for (i=0;i<57600;i=i+8) 
     {   
       SendData(*(p2+1)); SendData(*(p2));
       SendData(*(p2+3)); SendData(*(p2+2));
       SendData(*(p2+5)); SendData(*(p2+4));
       SendData(*(p2+7)); SendData(*(p2+6));
       p2=p2+8;
     }
      SQA=0;
      Stop_SMT1();
      CRLF1();
      CPrint(" ..fin Affichage Image voltmetre \r\n");
      CRLF1();
      Delay_xSec(2);
   
   }
  while(1);
  
}
/**
 End of File
 * 

(09:41:16.151)  Projet MPLABX : C:MPLABX_Projects<SOH>8F27K42_TEST_SPI_2023.X<SOH>8F27K42_TEST_SPI_20232
(09:41:16.151)  Version : 2022-0321
(09:41:16.151)  Compile le Mar 21 2023 a 09:40:27 UTC
(09:41:16.151)  avec version XC8 :  2360 et PACK PIC18F-K_DFP 1.6.125
(09:41:16.151)  Hardware : PIC18F27K42 , FOSC interne =64MHz 
(09:41:16.151)  UART1  RC6=TX  115200,8,N,1 
(09:41:16.151)  SPI HARDWARE at 8MHz:
(09:41:16.151)   RC3=SCLK  RC5=MOSI SDA  RC2=SS  , cdes sur PORTB  RB0=_RST RB1=_CS  RB2=_DC
(09:41:16.186) 
(09:41:16.186)  Init et Test Compteur 24 bits SMT1 CLOCK sur FOSC/4=16MHz
(09:41:16.186)  Se limiter  max mesure <= 2secondes
(09:41:16.186)  Mesure SMT1 pour __delay_ms(50);
(09:41:16.222)  Stop. SMT1=800006 ,soit 50000 uS
(09:41:16.230) 
(09:41:16.230)  Mesure SMT1 pour __delay_ms(500);
(09:41:16.732)  Stop. SMT1=8000006 ,soit 500000 uS
(09:41:16.744) 
(09:41:16.744)  Mesure SMT1 pour __delay_ms(2000);
(09:41:18.737)   Over !
(09:41:18.764)  Stop. SMT1=32000006 ,soit 2000000 uS
(09:41:18.764) 
(09:41:18.764)  My_Init SPI1
(09:41:18.764)  TEST signaux SCLK et  MOSI SPI Hardware avec SQA analyser (RA3=Synchro capture)
(09:41:18.764)  SPI HARDW Sequence : 0x01 0x10 0X20 0x40 0x80 0xAA 0x0F 0x55 0xF0 
(09:41:18.764)  Armer la capture dans 3 sec !
(09:41:21.762) 
(09:41:21.762)  Init OLED Rond CG9A01 
(09:41:21.798)  Start SMT1 pour Init_CG9A01(); 
(09:41:22.541)  Stop. SMT1=12401421 ,soit 775088 uS
(09:41:22.557) 
(09:41:22.557)  fin d'init LCD
(09:41:22.557) 
(09:41:22.557)  Clear_LCD() 
(09:41:22.842) 
(09:41:22.842)  Test duree Ecran Noir (SPI 8MHz!) 
(09:41:23.142)  Stop. SMT1=4666010 ,soit 291625 uS
(09:41:23.156) 
(09:41:23.156) 
(09:41:23.156)  Ecran Noir 
(09:41:23.437)  Rectangles Pleins Vert, Beige 
(09:41:26.356)  Rectangles Pleins Bleu,Blanc,Rouge 
(09:41:28.479)  put 8 big pixels 
(09:41:30.487)  Affichage voltmetre.bmp 240x240 65K couleurs .. OK 
(09:41:30.487)  Image datas organisee en 2 tables de 57600 Bytes  
(09:41:30.487) 
(09:41:30.487)  Test Duree de Chargement image Voltmetre.bmp 
(09:41:30.890)  Stop. SMT1=6321619 ,soit 395101 uS
(09:41:30.905) 
(09:41:30.905) 
(09:41:30.905)  ..fin Affichage Image voltmetre 
(09:41:30.905) 
(09:41:32.895)  Ecran Noir 
(09:41:33.185)  Rectangles Pleins Vert, Beige 
(09:41:36.100)  Rectangles Pleins Bleu,Blanc,Rouge 
(09:41:38.228)  put 8 big pixels 
(09:41:40.224)  Affichage voltmetre.bmp 240x240 65K couleurs .. OK 
(09:41:40.242)  Image datas organisee en 2 tables de 57600 Bytes  
(09:41:40.242) 
(09:41:40.242)  Test Duree de Chargement image Voltmetre.bmp 
(09:41:40.638)  Stop. SMT1=6321619 ,soit 395101 uS
(09:41:40.650) 
(09:41:40.650) 
(09:41:40.650)  ..fin Affichage Image voltmetre 
(09:41:40.650) 
(09:41:42.639)  Ecran Noir 

*****************************************************

 
Connecting to MPLAB PICkit 4

Currently loaded versions:
Application version...........00.07.28
Boot version..................01.00.00
Script version................00.04.97
Script build number...........76c444c118
Tool pack version ............1.12.1384
Target voltage detected
Target device PIC18F27K42 found.
Device Revision Id  = 0xa0010000

Calculating memory ranges for operation...

Erasing...

The following memory area(s) will be programmed:
program memory: start address = 0x0, end address = 0x1f2ff
configuration memory
User Id Memory
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
*/